<template>
  <div>
    <nav class="navbar sticky-top navbar-light bg-light shadow-sm">
      <div class="container">
        <a class="navbar-brand" href="#">Table Editor</a>
        <div class="d-flex flex-row bd-highlight">
          <div class="dropdown">
            <b-dropdown id="ddown-buttons" :text="$t('button.downloadTable')" class="m-2" size="sm" variant="info">
              <template v-for="(format, index) in allowedFormats">
                <a href="#" @click="downloadTable(format, $event)" class="dropdown-item" :key="index">{{ format }}</a>
              </template>
            </b-dropdown>
          </div>
        </div>
      </div>
    </nav>
    <div class="container">
      <div class="wrap">
        <b-tabs>
          <b-tab :title="$t('tab.table')">
            <Table :columns="columns" />
          </b-tab>
          <b-tab :title="$t('tab.data')">
            <Form/>
          </b-tab>
          <b-tab :title="$t('tab.upload')">
            <Loader/>
          </b-tab>
        </b-tabs>
      </div>
    </div>
    <nav class="navbar-nav fixed-bottom navbar-light bg-white">
      <div class="container">
        <div class="d-flex flex-row bd-highlight justify-content-end">
          <div class="p-2 bd-highlight">
            <button @click="addRow" class="btn btn-success btn-sm">{{ $t('button.addRow') }}</button>
          </div>
        </div>
      </div>
    </nav>
  </div>
</template>

<script>
import { DEFAULT_TABLE_COLUMNS, ALLOWED_DATA_TYPES, DEFAULT_ROW, genId, dataToString } from '@/lib'
import Table from '@/components/Table.vue'
import Form from '@/components/Form.vue'
import Loader from '@/components/Loader.vue'
import Schema from '@/schema/default'
import mockJSON from '@/mock/json'
import { EventBus } from '@/bus'
import { Store } from '@/store'

// JSON validator library
import Ajv from 'ajv'

// Init library
const ajv = new Ajv()

export default {
  name: 'TableEditor',
  data () {
    return Store.state
  },
  components: {
    Table,
    Form,
    Loader
  },
  created () {
    // Get loaded user data
    EventBus.$on('content:loaded', this.setupData)

    // Setup mock data when app init
    this.setupData(mockJSON)
  },
  computed: {
    // Return default colums array ['Name', 'Value']
    columns () {
      return DEFAULT_TABLE_COLUMNS
    },

    // Return allowed user content formats (['CSV', 'JSON'])
    allowedFormats () {
      return ALLOWED_DATA_TYPES
    }
  },
  methods: {
    /**
     * Setup new data
     * @param { String } content - CSV|JSON formated
     * @param { String } type - needed format (CSV|JSON)
     */
    setupData (data, type = '') {
      this.source = (type.length) ? this.parseContent(data, type) : data
      this.sourceString = JSON.stringify(this.source)
    },

    /**
     * Add row event broadcasting
     */
    addRow () {
      EventBus.$emit('row:added', DEFAULT_ROW)
    },

    /**
     * Start check content by type and parse
     * @param { Object } content - user content
     * @param { String } type - needed type
     */
    parseContent (content, type) {
      let result = []
      switch (type) {
        case 'json':
          result = this.parseJson(content)
          break
        case 'csv':
          result = this.parseCsv(content)
          break
        default:
          alert(this.$t('common.formatIsNotAllowed'))
      }
      return result
    },

    /**
     * Convert string to JSON
     * @param { String } string - any string
     */
    stringToJSON (string) {
      try {
        return JSON.parse(string)
      } catch (e) {
        return null
      }
    },

    /**
     * JSON context parsing
     * @param { String } content - JSON formated
     */
    parseJson (content) {
      var json = this.stringToJSON(content)
      try {
        if (json != null && this.isValidJSON(json)) {
          alert(this.$t('common.dataSuccess'))
        } else {
          json = Store.state.source || mockJSON
          throw new Error(this.$t('common.dataIsNotJson'))
        }
      } catch (e) {
        alert(e.message)
      } finally {
        // eslint-disable-next-line
        return json
      }
    },

    /**
     * CSV context parsing
     * @param { String } content - CSV formated
     */
    parseCsv (content) {
      let result = { rows: [] }
      let splitedContent = content.split('\n').slice(0, -1)
      let values = splitedContent.map(item => {
        return item.split(/,|;/g).slice(0, 2)
      })

      // Add row to result.rows
      result.rows = values.map((value, index) => {
        let row = {}
        for (let i = 0; i < value.length; i++) {
          row[DEFAULT_TABLE_COLUMNS[i].toLowerCase()] = value[i]
        }
        return row
      })

      try {
        if (!this.isValidJSON(result)) {
          throw new Error(this.$t('common.dataIsNotJson'))
        } else {
          alert(this.$t('common.dataSuccess'))
          return result
        }
      } catch (e) {
        alert(e.message)
      }
    },

    /**
     * Validate json
     * @param { Object } json
     */
    isValidJSON (json) {
      let validate = ajv.compile(Schema)
      let isValid = validate(json)
      // if(!isValid) console.log(json, validate.errors);
      return isValid
    },

    /**
     * Data download
     * @param { String } format - needed file format
     * @param { MouseEvent } event - click event
     */
    downloadTable (format, event) {
      // used dataToString from @/lib
      let data = dataToString(this.source, format)
      let blob = new Blob([data], { type: 'octet/stream' })
      let url = URL.createObjectURL(blob)

      event.target.href = url

      // Target filename
      event.target.download = `${genId('data')}.${format.toLowerCase()}`
    }
  }
}
</script>

<style lang="scss">
  .container {
    .wrap {
      padding-top: 20px;
    }

    .nav-tabs {
      border-bottom: 0;
    }

    .flex-row span {
      line-height: 2;
    }
  }
</style>
